/*
 ?
 ? Program..: XDEMO.PRG                                           ?
 ? Author...: Roger J. Donnay                                     ?
 ? Notice...: (c) DONNAY Software Designs 1987-2002               ?
 ? Date.....: Oct 5, 2005                                         ?
 ? Notes....: eXPress Demo Program                                ?
 ?

 This sample program is a menu system used to select one of five
 other demonstration programs included in XDEMO*.PRG and XSAMPLE*.PRG
*/

#include "dcdialog.ch"
#include "dcbitmap.ch"
#include "dcicon.ch"
#include "appevent.ch"
#include "inkey.ch"
#include "dchelp.ch"
#INCLUDE "dctree.CH"
#INCLUDE "dcmxbutt.CH"

#define VK_NUMLOCK        0x90
#define VK_SCROLL         0x91
#define VK_CAPITAL        0x14
#define APPKEY_PRESSED    2
#DEFINE CRLF              Chr(13)+Chr(10)

STATIC snToolBarFixedItems := 2

FUNCTION XDemo()

LOCAL Getlist, GetOptions, lDebugMode := .f., oDebug, ;
      oAppWindow := SetAppWindow(), oMenuBar, oMsgBox, ;
      cVersion, oStatBottom, oToolBottom, oMsgStatic, nFrameState, ;
      oNumStatic, oCapsStatic, oInsStatic, oThread, nWidth, ;
      nHeight, nWindowWidth, nWindowHeight, nColPixels, nRowPixels,;
      cSayFont, cGetFont, oDialog, aOptions, nWindowCol, nWindowRow, ;
      cPath, cCommand, oToolBar, nResDll, oStatTop, nScrollBars

DC_Gui(.t.)
DC_IconDefault(ICON_EXPRESS)
DC_GroupBoxFix(.t.)

nResDll := DllLoad('DCRES.DLL')
DC_BitmapResourceFile( nResDll )

ErrorBlock({|e|DC_ErrorGui(e)})

/// DllLoad('memwatch.dll')
DC_DotHotKey(xbeK_ALT_F12)
DC_SetKeyActive(.t.)
DC_GetPopupCaption({ '12.Arial Bold', BITMAP_PENCIL_S, 0 })
DC_GetPopupAutoHide(.t.)
SetKey(K_ALT_F9,{||DC_InspectThreads()})
SetKey(K_CTRL_TAB,{||SelectWindow(oDialog)})

DC_PushButtonStyle(1)

DC_AutoRestoreWindow( { HKEY_CURRENT_USER, 'Software\Donnay Software\eXpress++\Windows' } )
DC_AutoRestoreBrowse( { HKEY_CURRENT_USER, 'Software\Donnay Software\eXpress++\Browses' } )
DC_BitmapTransparentColor({192,192,192})

GetList := {}
SET PATH TO (DC_Path(AppName(.t.)) + '\..\..\DATA')

DC_ChDir(DC_Path(AppName(.t.)))
cPath := DC_CurPath()+'\..\DICT'

IF !MemoWrit(cPath + '\_x_','x')
  cCommand := '/C MKDIR ' + cPath
  RunShell(cCommand)
ENDIF

#if XPPVER > 1900000
  DC_Sett('ODIR',DC_CurPath()+'\..\OBJ19')
#else
  DC_Sett('ODIR',DC_CurPath()+'\..\OBJ182')
#endif
DC_Sett('EDITOR',DC_CurPath()+'\..\UTIL\EDITOR.BAT')
DC_Sett('PDIR',DC_CurPath()+'\..\SAMPLES\XDEMO')

DC_SetdCLIP(cPath)

DC_XbpMenuConfig( ;
  { GraMakeRGBColor({200,100,0}),;   //  1 - Sub Menu Background Color
    GraMakeRGBColor({245,245,255}),; //  2 - Sub Menu Vertical Bar Foreground Color
    GraMakeRGBColor({200,200,255}),; //  3 - Sub Menu Vertical Bar Background Color
    GraMakeRGBColor({124,124,255}),; //  4 - Sub Menu Outline Color
    '11.Arial Bold', ;               //  5 - Sub Menu Vertical Bar Font
    .F., ;
    '10.Marlett', ;                  //  6 - Sub Menu Check Character Font
    'b', ;                           //  7 - Sub Menu Check Character
    GraMakeRGBColor({0,0,0}), ;      //  8 - Menu Bar Foreground Color
    GraMakeRGBColor({0,200,255}), ;  //  9 - Menu Bar Background Color
    GraMakeRGBColor({0,0,0}),;       // 10 - Sub Menu Foreground Color
    '8.Arial' } )                    // 11 - Menu Bar Font

DCMENUBAR oMenuBar ;
   EVAL {|o|o:endMenu := DC_MergeBlocks(o:endMenu,{||oMsgBox:setCaption('')}) } ;
   HELPCODE 'XDEMO.MENUBAR' ;
   OWNERDRAW ;
   MENUBARFONT '10.Arial Bold' ;
   MENUBARCOLOR {0,0,0}, {000,200,255} ;
   SUBCOLOR {0,0,0}, {200,200,255} ;
   SUBBARFONT '11.Arial Bold' ;
   SUBBARCOLOR {255,100,100}, { 200,200,200 } ;
   ITEMFONT '10.Arial'

BuildMenu( GetList, @oMenuBar, .t., @oStatTop )

// Bottom Statusbar with message, scrollbar, buttons, key status
DCSTATUSBAR oStatTop HEIGHT 31 ALIGN DCGUI_ALIGN_TOP ;
      HELPCODE '.STATUSBAR_TOP' ;
      HIDE {||Empty(oToolBar:childList())}

@ 0,0 DCTOOLBAR oToolBar SIZE 100,31 PIXEL PARENT oStatTop ;
      BUTTONSIZE 32,31 HELPCODE '.TOOLBAR_TOP' FANCY ;
      TYPE XBPSTATIC_TYPE_TEXT ;
      EVAL {|o|o:setColorBG(DC_XbpMenuConfig()[10])}

DCADDBUTTON CAPTION BITMAP_TREE_M PARENT oToolbar ;
      ACTION {|o|o:=Thread():new(),o:start({|| TreeMenu()})} ;
      TOOLTIP 'Tree-View style menu;Build custom Tool-Bar'

// Bottom Statusbar with message, scrollbar, buttons, key status
DCSTATUSBAR oStatBottom HEIGHT 28 ALIGN DCGUI_ALIGN_BOTTOM ;
      HELPCODE '.STATUSBAR_BOTTOM'

@ 3,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
      SIZE 450,20 ;
      PARENT oStatBottom PIXEL OBJECT oMsgStatic ;
      HELPCODE '.BOTTOM_STATIC'

@ 1,2 DCSAY '' ;
      SIZE 450,18 ;
      SAYCENTER ;
      COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND ;
      OBJECT oMsgBox PARENT oMsgStatic PIXEL ;
      FONT '8.Tahoma' ;
      HELPCODE '.MESSAGE_BAR'

@ 3,0 DCTOOLBAR oToolBottom SIZE 84,20 BUTTONSIZE 40,20 ;
      TYPE XBPSTATIC_TYPE_RECESSEDBOX PARENT oStatBottom PIXEL ;
      HELPCODE '.BOTTOM_TOOLBAR'

DCADDBUTTON CAPTION '&Exit' ;
  ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
  PARENT oToolBottom PIXEL ;
  WHEN {||Valtype(DC_GetCargo(oDialog))#'L'.OR.!DC_GetCargo(oDialog)} ;
  TOOLTIP {'Exit;this;Demo;Program','36.Courier Bold',GRA_CLR_RED,GRA_CLR_YELLOW} ;
  HELPCODE '.EXIT_PROGRAM'

DCADDBUTTON TYPE XBPSTATIC_TYPE_RAISEDBOX SIZE 3,22 ;
  PARENT oToolBottom PIXEL

DCADDBUTTON CAPTION '~View' ;
  ACTION {||DC_ArrayView(AppDeskTop())} ;
  PARENT oToolBottom PIXEL ;
  TOOLTIP 'View/Browse the Application Object Tree' ;
  HELPCODE '.VIEW_DESKTOP_ARRAY'

@ 3,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
      SIZE 30,20 PARENT oStatBottom PIXEL OBJECT oCapsStatic ;
      HELPCODE '.CAPSLOCK_STATIC'

@ 3,1 DCSAY 'Caps' PARENT oCapsStatic ID 'CAPSLOCK' ;
      SAYSIZE 28,18 SAYCENTER PIXEL FONT '7.Helv' ;
      HELPCODE '.'

@ 3,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
      SIZE 30,20 PARENT oStatBottom PIXEL OBJECT oNumStatic ;
      HELPCODE '.NUMLOCK_STATIC'

@ 3,1 DCSAY 'Num' PARENT oNumStatic ID 'NUMLOCK' ;
      SAYSIZE 28,18 SAYCENTER PIXEL FONT '7.Helv' ;
      HELPCODE '.'

@ 3,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
      SIZE 30,20 PARENT oStatBottom PIXEL OBJECT oInsStatic ;
      HELPCODE '.INSERT_STATIC'

@ 3,1 DCSAY '' PARENT oInsStatic ID 'INSERT' ;
      SAYSIZE 28,18 SAYCENTER PIXEL FONT '7.Helv' ;
      HELPCODE '.'

@ 5,0 DCSAY 'p' FONT '12.Marlett' PARENT oStatBottom PIXEL SAYSIZE 20 ;
      EVAL {|o|o:disable()}


DCHOTKEY xbeK_INS ACTION {||ReadInsert(!ReadInsert())}

nWidth := AppDeskTop():currentSize()[1]
nHeight := AppDeskTop():currentSize()[2]

nWindowRow := 0

IF nWidth <= 800
  nWindowWidth := 640
  nWindowHeight := 500
  cSayFont := '7.Arial'
  cGetFont := '9.Courier New'
  nColPixels := 7
  nRowPixels := 20
ELSEIF nWidth <= 1024
  nWindowWidth := 800
  nWindowHeight := 600
  cSayFont := '8.Arial'
  cGetFont := '10.Courier New'
  nColPixels := 8.5
  nRowPixels := 24
ELSEIF nWidth <= 1280
  nWindowWidth := 1000
  nWindowHeight := 800
  cSayFont := '10.Arial'
  cGetFont := '11.Courier New'
  nColPixels := 10
  nRowPixels := 28
ELSE
  nWindowWidth := 1200
  nWindowHeight := 1000
  cSayFont := '11.Arial'
  cGetFont := '12.Courier New'
  nColPixels := 11.5
  nRowPixels := 32
ENDIF

IF nWindowRow+nWindowHeight > AppDeskTop():currentSize()[2]
  nWindowRow := AppDeskTop():currentSize()[2]-nWindowHeight
ENDIF

nScrollBars := nil
#if XPPVER > 1900000
  nScrollBars := XBP_SCROLLBAR_VERT + XBP_SCROLLBAR_HORIZ
#endif

nTeller := 0
do while !file("test.txt")
	nTeller ++
	if nTeller > 100
		msgbox("Geen logingegevens. Stoppen")
		close database
		quit
	endif
	sleep(10)
enddo
ferase("test.txt")

DCGETOPTIONS ;
   ICON ICON_EXPRESS ;
   NOBUSY ;
   SAYFONT cSayFont ;
   GETFONT cGetFont ;
   FONT cSayFont ;
   COLPIXELS nColPixels ;
   ROWPIXELS nRowPixels ;
   ROWSPACE nRowPixels ;
   TOOLTIPCOLOR GRA_CLR_BLACK, GRA_CLR_YELLOW ;
   TOOLTIPFONT '16.Courier Bold' ;
   RESTOREDEFAULTSBUTTON ;
   SCROLLBARS nScrollBars ;
   scalefactor { 1.5,1.5,1.5,1.5,.T.,.F.}

DC_GetOptDefault(GetOptions)

DCGETOPTIONS ;
   HELPCODE 'DESKTOP.XDEMO' ;
   AUTOWINDOWMENU ;
   MESSAGEINTO {|c|oMsgBox:setCaption(c)} ;
   BITMAP BITMAP_EXPRESS_BACKGROUND1 ;
   ABORTQUERY MSG {||DC_MsgBox(,,{'Exit eXPress++ Demo?'},,,,.t.)} ;
   CLOSEQUERY MSG {||DC_MsgBox(,,{'Exit eXPress++ Demo?'},,,,.t.)} ;
   HIDE ;
   SOURCEFILE __FILEPATH__ ;
   ;// SOURCEFILE DC_Path(AppName(.t.)) + '..\SAMPLES\XDEMO\XDEMO.PRG' ;
   EVAL {|o|SetTimerEvent(100,{||_UpdateStats(GetList)}, ;
            SetAppWindow(o))}

cVersion := '1.9'

FErase('XPP' + GetNetName())

// dc_readguidebug(2)

DCREAD GUI ;
   TITLE 'eXPress++ Version ' + cVersion OPTIONS GetOptions ;
   PARENT @oDialog ;
   OPTIONS GetOptions ;
   EVAL {|o|LoadHelpOptions(o) ;
            ,Set_MainWindow(o) ;
            ,Set_MessageBox(oMsgBox) ;
            ,Set_ToolBar(oToolBar) ;
            ,BuildToolBar(GetList) ;
			,MaximizeScreen(o) ;
            ,DC_ZoomTransparent(o) ;
            ,DC_MenuWhenChecked(oMenuBar) ;
            }

SetAppWindow(oAppWindow)

SetTimerEvent(0)

RETURN nil

* ------------

FUNCTION Set_MainWindow( oDialog )

STATIC soDialog
IF Valtype(oDialog) == 'O'
  soDialog := oDialog
ENDIF
RETURN soDialog

* ------------

FUNCTION Set_ToolBar( oToolBar )

STATIC soToolbar
IF Valtype(oToolbar) == 'O'
  soToolbar := oToolbar
ENDIF
RETURN soToolbar

* ------------

FUNCTION Set_MessageBox( oMsgBox )

STATIC soMsgBox
IF Valtype(oMsgBox) == 'O'
  soMsgBox := oMsgBox
ENDIF
RETURN soMsgBox

*-------------

FUNCTION BuildMenu( GetList, oParent, lMenuBar, oStatTop )

LOCAL oMenuFile, oMenuApp, oMenuSample, oMenuHelp, aBitmaps, oMsgBox, ;
      oDialog

oDialog := Set_MainWindow()
oMsgBox := Set_MessageBox()

DEFAULT lMenuBar := .F.

aBitMaps := BitmapConfig()

/* ---- File Submenu ---- */

DCSUBMENU oMenuFile PROMPT "~File" PARENT oParent ;
   MESSAGE 'Select Demo Run Mode' INTO oMsgBox ;
   HELPCODE '.FILE_SUBMENU' ;
   BARTEXT 'File' ;
   COLOR GRA_CLR_BLACK, {200,150,150} ;
   BITMAP GetBitmap(nil,aBitmaps,'FILE_MENU',lMenuBar) ;
   ID 'FILE_MENU' ;
   ITEMFONT '16.Lucida Console Bold'

  DCMENUITEM "~Tree Menu" PARENT oMenuFile ;
     ACTION _ActiveBlock( {||TreeMenu()}, @oStatTop ) ;
     MESSAGE 'Display this menu in a Tree-View' INTO oMsgBox ;
     ACCELKEY { Asc('T'), Asc('t') } ;
     HELPCODE '.TREE_VIEW' ;
     BITMAP GetBitmap(BITMAP_TREE_M,aBitmaps,'TREE_MENU',lMenuBar) ;
     ID 'TREE_MENU'

  DCMENUITEM "E~xit" PARENT oMenuFile ;
     ACTION _ActiveBlock( {|o|_XDemoExit(GetList)}, @oStatTop ) ;
     MESSAGE 'Quit the eXPress++ Demo Program' INTO oMsgBox ;
     ACCELKEY { Asc('X'), Asc('x') } ;
     HELPCODE '.EXIT' ;
     BITMAP GetBitmap(nil,aBitmaps,'EXIT_PROGRAM',lMenuBar) ;
     ID 'EXIT_PROGRAM'


/* ---- Application Submenu ---- */

DCSUBMENU oMenuApp PROMPT "~Applications" PARENT oParent ;
   MESSAGE 'Miscellaneous Applications (with source code)' INTO oMsgBox ;
   HELPCODE '.APPLICATIONS_SUBMENU' ;
   BARTEXT 'Applications' ;
   BGCOLOR {150,150,200} ;
   BITMAP GetBitmap(nil,aBitmaps,'APPLICATIONS',lMenuBar) ;
   ID 'APPLICATIONS' ;
   GROUP 'APPLICATIONS' ;
   NOBITMAPS

   DCMENUITEM "~Collection" PARENT oMenuApp ;
      MESSAGE 'My personal Inventory' INTO oMsgBox ;
      CHECKWHEN {||.t.} ;
      BITMAP GetBitmap(nil,aBitmaps,'COLLECTION',lMenuBar) ;
      HELPCODE '.COLLECTION_APPLICATION' ;
      ID 'COLLECTION' ;
      GROUP 'APPLICATIONS' ;
      ACTION _ActiveBlock( {|o|XDemo_1(Set_MainWindow():drawingArea)}, @oStatTop ) // XDEMO1.PRG

   DCMENUITEM "~Documentor - XDoc" PARENT oMenuApp ;
      MESSAGE 'My documentor' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'DOCUMENTOR',lMenuBar) ;
      HELPCODE '.DOCUMENTOR_APPLICATION' ;
      ID 'DOCUMENTOR' ;
      GROUP 'APPLICATIONS' ;
      ACTION _ActiveBlock( {|o|DC_XDoc(Set_MainWindow():drawingArea)}, @oStatTop )  // _DCXDOC.PRG

   DCMENUITEM "ClipBoard Capture - XC~lipDoc" PARENT oMenuApp ;
      MESSAGE 'My Clipboard Capture' INTO oMsgBox ;
      HELPCODE '.CLIPBOARD_APPLICATION' ;
      BITMAP GetBitmap(nil,aBitmaps,'CLIPBOARD',lMenuBar) ;
      ID 'CLIPBOARD' ;
      GROUP 'APPLICATIONS' ;
      ACTION _ActiveBlock( {|o|XClipDoc(Set_MainWindow():drawingArea)}, @oStatTop )  // CLIPDOC.PRG

   DCMENUITEM '' PARENT oMenuApp WHEN {||.f.}

   DCMENUITEM '' PARENT oMenuApp WHEN {||.f.}

/* ---- Samples Submenu ---- */

DCSUBMENU oMenuSample PROMPT "~Samples" PARENT oParent ;
   MESSAGE 'Miscellanous Samples and Demo Programs (with source code)' ;
     INTO oMsgBox ;
   HELPCODE '.SAMPLES_SUBMENU' ;
   BARTEXT 'Samples' ;
   BGCOLOR {150,200,150} ;
   ID 'SAMPLES_MENU' ;
   GROUP 'SAMPLES' ;
   BITMAP GetBitmap(nil,aBitmaps,'SAMPLES_MENU',lMenuBar)

   DCMENUITEM "Sample Group ~1" PARENT oMenuSample  ;
      MESSAGE 'Run Sample Group #1' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'SAMPLE_GROUP_1',lMenuBar) ;
      HELPCODE '.SAMPLE_GROUP_1' ;
      ID 'SAMPLE_GROUP_1' ;
      GROUP 'SAMPLES' ;
      ACTION _ActiveBlock( {|o|X_Samples_1(Set_MainWindow():drawingArea)}, @oStatTop )  // XSAMPLE1.PRG

   DCMENUITEM "Sample Group ~2" PARENT oMenuSample ;
      MESSAGE 'Run Sample Group #2' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'SAMPLE_GROUP_2',lMenuBar) ;
      HELPCODE '.SAMPLE_GROUP_2' ;
      ID 'SAMPLE_GROUP_2' ;
      GROUP 'SAMPLES' ;
      ACTION _ActiveBlock( {|o|X_Samples_2(Set_MainWindow():drawingArea)}, @oStatTop )  // XSAMPLE2.PRG

   DCMENUITEM "Sample Group ~3" PARENT oMenuSample ;
      MESSAGE 'Run Sample Group #3' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'SAMPLE_GROUP_3',lMenuBar) ;
      HELPCODE '.SAMPLE_GROUP_3' ;
      ID 'SAMPLE_GROUP_3' ;
      GROUP 'SAMPLES' ;
      ACTION _ActiveBlock( {|o|X_Samples_3(Set_MainWindow():drawingArea)}, @oStatTop )  // XSAMPLE3.PRG

   DCMENUITEM "Sample Group ~4" PARENT oMenuSample ;
      MESSAGE 'Run Sample Group #4' INTO oMsgBox ;
      BITMAP GetBitmap(nil, aBitmaps,'SAMPLE_GROUP_4',lMenuBar) ;
      HELPCODE '.SAMPLE_GROUP_4' ;
      ID 'SAMPLE_GROUP_4' ;
      GROUP 'SAMPLES' ;
      ACTION _ActiveBlock( {|o|X_Samples_4(Set_MainWindow():drawingArea)}, @oStatTop )  // XSAMPLE4.PRG

   DCMENUITEM "Sample Group ~5" PARENT oMenuSample ;
      MESSAGE 'Run Sample Group #5' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'SAMPLE_GROUP_5',lMenuBar) ;
      HELPCODE '.SAMPLE_GROUP_5' ;
      ID 'SAMPLE_GROUP_5' ;
      GROUP 'SAMPLES' ;
      ACTION _ActiveBlock( {|o|X_Samples_5(Set_MainWindow():drawingArea)}, @oStatTop )  // XSAMPLE5.PRG

   DCMENUITEM "Sample Group ~6" PARENT oMenuSample ;
      MESSAGE 'Run Sample Group #6' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'SAMPLE_GROUP_6',lMenuBar) ;
      HELPCODE '.SAMPLE_GROUP_6' ;
      ID 'SAMPLE_GROUP_6' ;
      GROUP 'SAMPLES' ;
      ACTION _ActiveBlock( {|o|X_Samples_6(Set_MainWindow():drawingArea)}, @oStatTop )  // XSAMPLE6.PRG

   DCMENUITEM SEPARATOR PARENT oMenuSample GROUP 'SAMPLES'

   DCMENUITEM "~Demo Program 2" PARENT oMenuSample ;
      MESSAGE 'Run Demo Program #2' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'DEMO_PROGRAM_2',lMenuBar) ;
      HELPCODE '.DEMO_PROGRAM_2' ;
      ID 'DEMO_PROGRAM_2' ;
      GROUP 'SAMPLES' ;
      ACTION _ActiveBlock( {|o|XDemo_2(Set_MainWindow():drawingArea)}, @oStatTop ) // XDEMO2.PRG

   DCMENUITEM "Demo ~Program 3" PARENT oMenuSample ;
      MESSAGE 'Run Demo Program #3' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'DEMO_PROGRAM_3',lMenuBar) ;
      HELPCODE '.DEMO_PROGRAM_3' ;
      ID 'DEMO_PROGRAM_3' ;
      GROUP 'SAMPLES' ;
      ACTION _ActiveBlock( {|o|XDemo_3(Set_MainWindow():drawingArea)}, @oStatTop ) // XDEMO3.PRG

   DCMENUITEM "Demo P~rogram 4 (Gui)" PARENT oMenuSample ;
      MESSAGE 'Run Demo Program #4 in Gui Mode' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'DEMO_PROGRAM_4_GUI',lMenuBar) ;
      HELPCODE '.DEMO_PROGRAM_4_GUI' ;
      ID 'DEMO_PROGRAM_4_GUI' ;
      GROUP 'SAMPLES' ;
      ACTION _ActiveBlock( {|o|XDemo_4(Set_MainWindow():drawingArea,.t.)}, @oStatTop )  // XDEMO4.PRG

   DCMENUITEM "Demo Pr~ogram 4 (Text)" PARENT oMenuSample ;
      MESSAGE 'Run Demo Program #4 in Text Mode' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'DEMO_PROGRAM_4_TEXT',lMenuBar) ;
      HELPCODE '.DEMO_PROGRAM_4_TEXT' ;
      ID 'DEMO_PROGRAM_4_TEXT' ;
      GROUP 'SAMPLES' ;
      ACTION _ActiveBlock( {|o|XDemo_4(Set_MainWindow():drawingArea,.f.)}, @oStatTop ) // XDEMO4.PRG

   DCMENUITEM "Demo Pro~gram 5" PARENT oMenuSample ;
      MESSAGE 'Run Demo Program #5' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'DEMO_PROGRAM_5',lMenuBar) ;
      HELPCODE '.DEMO_PROGRAM_5' ;
      ID 'DEMO_PROGRAM_5' ;
      GROUP 'SAMPLES' ;
      ACTION _ActiveBlock( {|o|XDemo_5(Set_MainWindow():drawingArea)}, @oStatTop )  // XDEMO5.PRG

   DCMENUITEM SEPARATOR PARENT oMenuSample GROUP 'SAMPLES'

   DCMENUITEM "Image ~Viewer" PARENT oMenuSample ;
      MESSAGE 'Run the Alaska Image Viewer Example' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'IMAGE_VIEWER',lMenuBar) ;
      HELPCODE '.DEMO_PROGRAM_IMAGEVIEW' ;
      ID 'IMAGE_VIEWER' ;
      GROUP 'SAMPLES' ;
      ACTION _ActiveBlock( {|o|ImgView(Set_MainWindow():drawingArea)}, @oStatTop )   // IMGVIEW.PRG

DCSUBMENU oMenuHelp PROMPT "~Help" PARENT oParent ;
   MESSAGE 'Help Menu' ;
     INTO oMsgBox ;
   HELPCODE '.HELP_SUBMENU' ;
   BARTEXT 'Help' ;
   BGCOLOR {200,150,200} ;
   ID 'HELP_MENU' ;
   GROUP 'HELP' ;
   BITMAP GetBitmap(nil,aBitmaps,'HELP_MENU',lMenuBar)

   DCMENUITEM "~Help Contents" PARENT oMenuHelp ;
      MESSAGE 'Open a Help Window with Help Tree' INTO oMsgBox ;
      HELPCODE '.HELP_WINDOW' ;
      BITMAP GetBitmap(nil,aBitmaps,'HELP_CONTENTS',lMenuBar) ;
      ACTION {||PostAppEvent( xbeP_Keyboard, xbeK_F1,, Set_MainWindow() )} ;
      ID 'HELP_CONTENTS' ;
      GROUP 'HELP'

   DCMENUITEM SEPARATOR PARENT oMenuHelp GROUP 'HELP'

   DCMENUITEM "~About" PARENT oMenuHelp ;
      MESSAGE 'About eXpress++' INTO oMsgBox ;
      BITMAP GetBitmap(nil,aBitmaps,'ABOUT',lMenubar) ;
      HELPCODE '.ABOUT_EXPRESS' ;
      ACTION {||About()} ;
      ID 'ABOUT' ;
      GROUP 'HELP'

RETURN nil

* -------------------

FUNCTION GetBitmap( cDefaultBitmap, aBitmaps, cID, lMenuBar )

LOCAL nIndex, aBitmap, lVer19 := .F.

#if XPPVER > 1900000
  lVer19 := .T.
#endif

nIndex := AScan( aBitmaps, {|a|a[1]==cId} )
IF nIndex == 0
  IF Empty(cDefaultBitmap) .AND. !lMenuBar
    cDefaultBitmap := BITMAP_FRAMEOUTLINE_M // Required to make tree display correctly with bitmaps
  ENDIF
  IF !lVer19
    IF lMenuBar
      RETURN nil
    ELSE
      RETURN cDefaultBitmap
    ENDIF
  ELSE
    RETURN cDefaultBitmap
  ENDIF
ENDIF

IF !lVer19 .AND. lMenuBar
  RETURN nil
ENDIF

aBitmap := aBitmaps[nIndex,2,1]

RETURN aBitmap

* -------------------

FUNCTION BitmapConfig( aBitmaps, lSaveToFile )

LOCAL cFileName := DC_Path(AppName(.t.)) + 'XDemo_Icons.Cfg'

STATIC saBitmaps

DEFAULT lSaveToFile := .F.

IF File(cFileName) .OR. lSaveToFile
  IF Valtype(aBitmaps) == 'A'
    DC_ASave( aBitmaps, cFileName )
    saBitmaps := aBitmaps
  ELSE
    IF Empty(saBitmaps)
      saBitmaps := DC_Arestore(cFileName)
    ENDIF
  ENDIF
ELSE
  IF Valtype(aBitmaps) == 'A'
    DC_RegWrite(HKEY_CURRENT_USER, ;
             'Software\Donnay Software\eXpress++','Bitmaps', aBitmaps )
    saBitmaps := aBitmaps
  ELSE
    saBitmaps := DC_RegQuery(HKEY_CURRENT_USER, ;
                'Software\Donnay Software\eXpress++','Bitmaps')
  ENDIF
ENDIF

RETURN saBitmaps

* -------------------

FUNCTION ToolbarConfig( aButtons, lSaveToFile )

STATIC saButtons

LOCAL cFileName := DC_Path(AppName(.t.)) + 'XDemo_Toolbar.Cfg'

DEFAULT lSaveToFile := .F.

IF File(cFileName) .OR. lSaveToFile
  IF Valtype(aButtons) == 'A'
    DC_ASave( aButtons, cFileName )
    saButtons := aButtons
  ELSE
    IF Empty(saButtons)
      saButtons := DC_Arestore(cFileName)
    ENDIF
  ENDIF
ELSE
  IF Valtype(aButtons) == 'A'
    DC_RegWrite(HKEY_CURRENT_USER, ;
               'Software\Donnay Software\eXpress++','Toolbar', aButtons )
    saButtons := aButtons
  ELSE
    IF Empty(saButtons)
      saButtons := DC_RegQuery(HKEY_CURRENT_USER, ;
                  'Software\Donnay Software\eXpress++','Toolbar')
    ENDIF
  ENDIF
ENDIF

RETURN saButtons

* -------------------

FUNCTION TreeMenu()

LOCAL GetList[0], oTree, GetOptions, oMenu, cID, oDialog, oToolBar

oDialog := Set_MainWindow()
oToolBar := Set_ToolBar()

@ 0,0 DCSAY 'Right-Click with the mouse to build Toolbar' SAYSIZE 0 ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y PIXEL

@ 20,0 DCTREEROOT OBJECT oTree SIZE 300,400 PIXEL HASBUTTONS HASLINES ;
      ALWAYSSHOWSELECTION ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      EVAL {|o|o:lbClick := {|aPos|oTree:SetData(oTree:itemFromPos(aPos))}, ;
               o:rbDown := ;
                   {|aPos,b,o|DC_GetWhen(GetList), ;
                   oTree:SetData(oTree:itemFromPos(aPos)), ;
                   oMenu:popup( o, aPos, 2, ;
            XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN )} }

BuildMenu( GetList, @oTree )

DCSUBMENU oMenu PROMPT 'Toolbar' OWNERDRAW

  DCMENUITEM 'Add this item to Toolbar' PARENT oMenu ;
    ACTION {|oItem|oItem := oTree:getData(), ;
                   AddToToolBar(oItem) } ;
    WHEN {|aButtons,aBitmaps| ;
                    cID := DC_GetProperty(oTree:getData(),cGETLIST_ID), ;
                    aButtons := ToolbarConfig(), ;
                    aBitmaps := BitmapConfig(), ;
                    AScan(aButtons,{|c|c==cID}) = 0 .AND. ;
                    AScan(aBitmaps,{|a|a[1]==cID}) > 0}

  DCMENUITEM 'Remove this item from Toolbar' PARENT oMenu ;
    ACTION {|oItem|oItem := oTree:getData(), ;
                   RemoveFromToolBar(oItem)} ;
    WHEN {|aButtons|cID := DC_GetProperty(oTree:getData(),cGETLIST_ID), ;
                    aButtons := ToolbarConfig(), ;
                    AScan(aButtons,{|c|c==cID})>0}

  DCMENUITEM 'Choose Icon for this Item' PARENT oMenu ;
    ACTION {|oItem|oItem := oTree:getData(), ;
                   ChooseBitmap(oItem)}

   DCMENUITEM 'Remove Icon for this Item' PARENT oMenu ;
      ACTION {|oItem|oItem := oTree:getData(), ;
      RemoveBitmap(oItem)}

  DCMENUITEM 'Empty the Toolbar' PARENT oMenu ;
    ACTION {||ClearToolBar(.t.)} ;
    WHEN {||!Empty(oToolBar:childList())}

  DCMENUITEM 'Choose Button Style for the Toolbar' PARENT oMenu ;
    ACTION {||ChooseButtonStyle()}

@ 425, 0 DCPUSHBUTTON CAPTION 'Exit' SIZE 70,22 PIXEL ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}

@ DCGUI_ROW, DCGUI_COL + 5 DCPUSHBUTTON CAPTION 'Expand' SIZE 70,22 PIXEL ;
      ACTION {||oTree:lockUpdate(.t.),;
                DC_ExpandTree(oTree:rootItem,.t.), ;
                SetAppFocus(oTree), ;
                oTree:keyboard(xbeK_CTRL_PGUP), ;
                oTree:lockUpdate(.f.) }

@ DCGUI_ROW, DCGUI_COL + 5 DCPUSHBUTTON CAPTION 'Collapse' SIZE 70,22 PIXEL ;
      ACTION {||oTree:lockUpdate(.t.), ;
                DC_ExpandTree(oTree:rootItem,.f.), ;
                SetAppFocus(oTree), ;
                oTree:keyboard(xbeK_CTRL_PGUP), ;
                oTree:lockUpdate(.f.) }

@ DCGUI_ROW, DCGUI_COL + 5 DCPUSHBUTTON CAPTION 'Save' SIZE 70,22 PIXEL ;
      ACTION {||SaveDefaults()}

DCGETOPTIONS RESIZE HIDE

DCREAD GUI FIT APPWINDOW oDialog:drawingArea ;
   NOAUTORESTORE ;
   TITLE 'Tree-View Menu' OPTIONS GetOptions ;
   EVAL {|o|DC_ExpandTree(oTree:rootItem,.t.), ;
            o:setPos({0,0}), ;
            o:setSize({o:currentSize()[1],oDialog:drawingArea:currentSize()[2]}), ;
            o:show()}

RETURN nil

* -------------------

FUNCTION SaveDefaults()

LOCAL GetList[0], GetOptions, nSaveTool, nSaveIcon, lStatus
LOCAL cIconFileName := DC_Path(AppName(.t.)) + 'XDemo_Icons.Cfg'
LOCAL cToolbarFileName := DC_Path(AppName(.t.)) + 'XDemo_Toolbar.Cfg'
LOCAL aButtons, aBitmaps, oToolGroup, oIconGroup

IF File(cToolbarFileName)
  nSaveTool := 2
ELSE
  nSaveTool := 1
ENDIF

IF File(cIconFileName)
  nSaveIcon := 2
ELSE
  nSaveIcon := 1
ENDIF

@ 0,0 DCGROUP oToolGroup SIZE 50,6 CAPTION 'Toolbar Selections'
DCSETPARENT TO oToolGroup

@ 1.5,2 DCSAY 'Toolbar selections are automatically saved to the Windows ;' + ;
            'Registry unless a file named XDemo_ToolBar.cfg is found;' + ;
            'in the same directory as XDemo.Exe' ;
            SAYWORDBREAK SAYSIZE 0, 2

@ 3,2 DCRADIOBUTTON nSaveTool VALUE 1 PROMPT 'Save to Windows Registry'

@ 4,2 DCRADIOBUTTON nSaveTool VALUE 2 PROMPT 'Save to XDemo_ToolBar.cfg file'

DCSETPARENT TO

@ 6.5,0 DCGROUP oIconGroup SIZE 50,6 CAPTION 'Icon Selections'
DCSETPARENT TO oIconGroup

@ 1.5,2 DCSAY 'Icon selections are automatically saved to the Windows ;' + ;
            'Registry unless a file named XDemo_Icons.cfg is found;' + ;
            'in the same directory as XDemo.Exe' ;
            SAYWORDBREAK SAYSIZE 0, 2

@ 3,2 DCRADIOBUTTON nSaveIcon VALUE 1 PROMPT 'Save to Windows Registry'

@ 4,2 DCRADIOBUTTON nSaveIcon VALUE 2 PROMPT 'Save to XDemo_Icons.cfg file'

DCREAD GUI FIT ;
   ADDBUTTONS ;
   TO lStatus ;
   NOAUTORESTORE ;
   TITLE 'Save Toolbar / Icon Configuration'

IF lStatus
  aBitmaps := BitmapConfig()
  aButtons := ToolbarConfig()
  IF nSaveIcon == 2 .AND. File(cIconFileName)
    Ferase(cIconFileName)
  ENDIF
  IF nSaveTool == 2 .AND. File(cToolbarFileName)
    Ferase(cToolBarFileName)
  ENDIF
  BitmapConfig( aBitmaps, nSaveIcon == 2 )
  ToolbarConfig( aButtons, nSaveTool == 2 )
  DCMSGBOX 'Done!'
ENDIF

RETURN nil

* -------------------

FUNCTION AddToToolBar( oItem )

LOCAL aButtons, cId, aBitmap

aButtons := ToolbarConfig()

DEFAULT aButtons := {}

cId := DC_GetProperty( oItem, cGETLIST_ID )
aBitmap := DC_GetProperty( oItem, xGETLIST_OPTIONS2 )

AAdd( aButtons, cID )

ToolbarConfig( aButtons ) // Save buttons

BuildToolBar()

RETURN nil

* -------------------

FUNCTION RemoveFromToolBar( oItem )

LOCAL aButtons, cId, nIndex

aButtons := ToolbarConfig()

DEFAULT aButtons := {}

IF oItem:isDerivedFrom('XbpTreeViewItem')
  cId := DC_GetProperty( oItem, cGETLIST_ID )
ELSE
  cId := DC_GetCargo(oItem)
ENDIF

nIndex := AScan( aButtons, {|c|c==cId} )
IF nIndex == 0
  RETURN nil
ENDIF

ARemove( aButtons, nIndex )

ToolbarConfig( aButtons )

BuildToolBar()

RETURN nil

* -------------------

FUNCTION MoveButton( oButton, nMode )

LOCAL aButtons, cId, nIndex, aButton

aButtons := ToolbarConfig()

DEFAULT aButtons := {}

cId := DC_GetCargo(oButton)

nIndex := AScan( aButtons, {|c|c==cId} )
IF nIndex == 0
  RETURN nil
ENDIF

IF nIndex == 1 .AND. nMode == 1  // Move left
  RETURN nil
ENDIF

IF nIndex == Len(aButtons) .AND. nMode == 2  // Move right
  RETURN nil
ENDIF

aButton := aButtons[nIndex]

ARemove( aButtons, nIndex )

ASize( aButtons, Len(aButtons) + 1 )
IF nMode = 2 // Move right
  AIns( aButtons, nIndex + 1, aButton )
ELSE  // Move left
  AIns( aButtons, nIndex - 1, aButton )
ENDIF

ToolbarConfig( aButtons )

BuildToolBar()

RETURN nil

*--------------------

static function MoveButtonArbitrary(oXbp,nMode)

LOCAL GetList[0], i, aButtons, nMoves := 1, lOk := .T.

IF ValType(nMode) == 'N'

  aButtons := ToolbarConfig()
  FOR i := 1 TO Len(aButtons)
    MoveButton(oXbp,nMode,.F.)
  NEXT
  BuildToolBar( )

ELSE

  @ 0,0 DCSAY "Enter Number ('-' moves left)" GET nMoves GETSIZE 5 PICTURE "999"
  DCREAD GUI FIT ADDBUTTONS TO lOk TITLE 'Move Button' MODAL

  IF lOk
    IF ABS(nMoves) > 0
      FOR i := 1 TO ABS(nMoves)
        MoveButton(oXbp,IIF( nMoves > 0, 2, 1 ),.F.)
      NEXT
      BuildToolBar()
    ELSE
      DC_WinAlert("You Did Not Enter A Number")
    ENDIF
  ENDIF

ENDIF

return nil

* -------------------

FUNCTION AddSeparator( oButton, nWidth )

LOCAL aButtons, cId, nIndex, nCount, cCount, cNextButton, ;
      nNextButton, nButton, cButton, i, cWidth

aButtons := ToolbarConfig()

DEFAULT aButtons := {}, ;
        nWidth := 5

cId := DC_GetCargo(oButton)

nIndex := AScan( aButtons, {|c|c==cId} )
IF nIndex == 0
  RETURN nil
ENDIF

nNextButton := 0
FOR i := 1 TO Len(aButtons)

  cButton := aButtons[i]
  IF cButton = 'MENUITEM_SEPARATOR'
    nButton := Val(SubStr(cButton,23))
    nNextButton := Max(nNextButton,nButton)
  ENDIF

NEXT

cNextButton := Str(nNextButton+1,4)
cWidth := Str(nWidth,2)

cButton := 'MENUITEM_SEPARATOR_' + DC_PadZero(cWidth,2) + ;
           '_' + DC_PadZero(cNextButton,4)

ASize( aButtons, Len(aButtons) + 1 )
AIns( aButtons, nIndex, cButton )

ToolbarConfig( aButtons )

BuildToolBar()

RETURN nil

* -------------------

FUNCTION ClearToolBar( lClearRegistry )

LOCAL aChildren, i, oToolBar

oToolBar := Set_ToolBar()

aChildren := oToolBar:childList()
FOR i := snToolBarFixedItems + 1 TO Len(aChildren)
  aChildren[i]:destroy()
NEXT

oToolBar:buttonCol := ((snToolBarFixedItems-1) * 28) + 5
oToolBar:buttonRow := 0

IF lClearRegistry
  ToolbarConfig( {} )
ENDIF

RETURN nil

* -------------------

FUNCTION BuildToolBar()

LOCAL GetList[0], aButtons, i, j, aBitmap, aGetList[0], cId, ;
      nIndex, cCaption, bAction, cGroup, aMenuGetList[0], ;
      cToolTip, cMessage, GetOptions, aBitmaps, oButtonMenu, ;
      oXbp, nWidth, oSepMenu, oParent, oToolBar, nSort := 1, ;
      nColor, nSepType, aButtonStyle

oToolBar := Set_ToolBar()
oParent := oToolBar:setParent()

aButtonStyle := DC_RegQuery(HKEY_CURRENT_USER, ;
               'Software\Donnay Software\eXpress++','ButtonStyle' )

DEFAULT aButtonStyle := { 1, { 255,255,255 } }

BuildMenu( aGetList, oParent,, 3 )

ClearToolBar( .F. )

aButtons := ToolbarConfig()

aBitmaps := BitmapConfig()

DEFAULT aBitmaps := {}

DEFAULT aButtons := {}

IF Empty(aButtons)
  aButtons := { cId }
  ToolbarConfig(aButtons)
ENDIF

FOR j := 1 TO Len(aGetList)
  AAdd( aMenuGetList, aGetList[j] )
NEXT j

FOR i := 1 TO Len(aButtons)

  cId := aButtons[i]

  IF Empty(cId)
    LOOP
  ENDIF

  nIndex := AScan( aGetList, {|a|a[cGETLIST_ID]==cId} )

  IF nIndex > 0

    aBitmap := aGetlist[nIndex,xGETLIST_OPTIONS2]

    DEFAULT aBitMap := {}
    ASize(aBitMap,2)
    cCaption := aBitMap[1]
    IF Empty(cCaption)
      cCaption := aGetList[nIndex,cGETLIST_CAPTION]
    ENDIF
    bAction := aGetList[nIndex,bGETLIST_ACTION]
    cGroup := aGetList[nIndex,cGETLIST_GETGROUP]

    IF Empty(bAction)
      bAction := PopupAction( aGetList[nIndex] )
    ENDIF

    cToolTip := aGetlist[nIndex,cGETLIST_CAPTION]
    DEFAULT cToolTip := ''
    cToolTip := Strtran(cToolTip,'~','')
    cMessage := aGetlist[nIndex,cGETLIST_MESSAGE]
    IF Valtype(cMessage) = 'A'
      cMessage := cMessage[1]
    ENDIF
    DEFAULT cMessage := ''

    IF aButtonStyle[1] == 2

      DCMXADDBUTTON ;
       BITMAP cCaption BMPOS 3,3 ;
       COLOR nil, aButtonStyle[2] ;
       PARENT oToolBar ;
       WHEN aGetList[nIndex,bGETLIST_WHEN] ;
       ACTION bAction ;
       TOOLTIP cToolTip + IIF(Empty(cMessage),'',';;' + cMessage) ;
       CARGO cId ;
       EVAL {|o|o:rbDown := ;
             {|p,q,o|oXbp := o, ;
              oButtonMenu:popup(o:setparent(), o:currentpos(),, ;
              XBPMENU_PU_DEFAULT+XBPMENU_PU_MOUSE_RBDOWN)} }

    ELSE

      DCADDBUTTON ;
        CAPTION cCaption ;
        FANCY ;
        PARENT oToolBar ;
        WHEN aGetList[nIndex,bGETLIST_WHEN] ;
        ACTION bAction ;
        TOOLTIP cToolTip + IIF(Empty(cMessage),'',';;' + cMessage) ;
        CARGO cId ;
        EVAL {|o|o:rbDown := ;
            {|p,q,o|oXbp := o, ;
             oButtonMenu:popup(o:setparent(), o:currentpos(),, ;
             XBPMENU_PU_DEFAULT+XBPMENU_PU_MOUSE_RBDOWN)} }

    ENDIF

    ATail(GetList)[cGETLIST_LEVEL] := Str(nSort++,3)

  ELSEIF cId = 'MENUITEM_SEPARATOR'

    nWidth := Val(Substr(cId,20))
    IF nWidth == 0
      nWidth := 2
      nSepType := XBPSTATIC_TYPE_RAISEDBOX
    ELSE
      nSepType := XBPSTATIC_TYPE_TEXT
    ENDIF

    DCADDBUTTON ;
      TYPE nSepType ;
      SIZE nWidth ;
      PARENT oToolBar ;
      COLOR nil, nColor ;
      CARGO cId ;
      EVAL {|o|o:rbDown := ;
                {|p,q,o|oXbp := o, ;
                  oSepMenu:popup(o:setparent(), o:currentpos(),, ;
                  XBPMENU_PU_DEFAULT+XBPMENU_PU_MOUSE_RBDOWN)} } ;
      TOOLTIP 'This is a ' + Alltrim(Str(nWidth)) + '-pixel separator;Right-Click to move or delete'

    ATail(GetList)[cGETLIST_LEVEL] := Str(nSort++,3)

  ENDIF

NEXT i

ASort( GetList,,,{|a,b|a[cGETLIST_LEVEL] < b[cGETLIST_LEVEL]} )
FOR i := 1 TO Len(aMenuGetList)
  AAdd(GetList,aMenuGetList[i])
NEXT

DCSUBMENU oButtonMenu PROMPT 'Button' PARENT oParent // OWNERDRAW

  DCMENUITEM 'Add Buttons to this Toolbar' PARENT oButtonMenu ;
    ACTION {|o|o:=Thread():new(),o:start({|| TreeMenu(.t.)})}

  DCMENUITEM 'Remove Button' PARENT oButtonMenu  ;
      ACTION {|a,b,o|RemoveFromToolBar(oXbp)}

  DCMENUITEM SEPARATOR PARENT oButtonMenu

  DCMENUITEM 'Move Button Left' PARENT oButtonMenu  ;
      ACTION {|a,b,o|MoveButton(oXbp,1)}

  DCMENUITEM 'Move Button Right' PARENT oButtonMenu  ;
      ACTION {|a,b,o|MoveButton(oXbp,2)}

  DCMENUITEM 'Move Button Arbitrary' PARENT oButtonMenu  ;
      ACTION {|a,b,o|MoveButtonArbitrary(oXbp)}

  DCMENUITEM 'Move Button To First Position' PARENT oButtonMenu  ;
      ACTION {|a,b,o|MoveButtonArbitrary(oXbp,1)}

  DCMENUITEM 'Move Button To Last Position' PARENT oButtonMenu  ;
      ACTION {|a,b,o|MoveButtonArbitrary(oXbp,2)}

  DCMENUITEM SEPARATOR PARENT oButtonMenu

  DCMENUITEM 'Insert a 5-pixel Separator' PARENT oButtonMenu  ;
      ACTION {|a,b,o|AddSeparator(oXbp,5)}

  DCMENUITEM 'Insert a 10-pixel Separator' PARENT oButtonMenu  ;
      ACTION {|a,b,o|AddSeparator(oXbp,10)}

  DCMENUITEM 'Insert a 15-pixel Separator' PARENT oButtonMenu  ;
      ACTION {|a,b,o|AddSeparator(oXbp,15)}

  DCMENUITEM 'Insert a Vertical Separator' PARENT oButtonMenu  ;
      ACTION {|a,b,o|AddSeparator(oXbp,0)}

DCSUBMENU oSepMenu PROMPT 'Separator' PARENT oParent // OWNERDRAW

  DCMENUITEM 'Remove Separator' PARENT oSepMenu  ;
      ACTION {|a,b,o|RemoveFromToolBar(oXbp)}

  DCMENUITEM SEPARATOR PARENT oSepMenu

  DCMENUITEM 'Move Separator Left' PARENT oSepMenu  ;
      ACTION {|a,b,o|MoveButton(oXbp,1)}

  DCMENUITEM 'Move Separator Right' PARENT oSepMenu  ;
      ACTION {|a,b,o|MoveButton(oXbp,2)}

  DCMENUITEM SEPARATOR PARENT oSepMenu

  DCMENUITEM 'Insert a 5-pixel Separator' PARENT oSepMenu  ;
      ACTION {|a,b,o|AddSeparator(oXbp,5)}

  DCMENUITEM 'Insert a 10-pixel Separator' PARENT oSepMenu  ;
      ACTION {|a,b,o|AddSeparator(oXbp,10)}

  DCMENUITEM 'Insert a 15-pixel Separator' PARENT oSepMenu  ;
      ACTION {|a,b,o|AddSeparator(oXbp,15)}

  DCMENUITEM 'Insert a Vertical Separator' PARENT oSepMenu  ;
      ACTION {|a,b,o|AddSeparator(oXbp,0)}

DCGETOPTIONS TOOLTIPCOLOR GRA_CLR_BLACK, GRA_CLR_YELLOW

DCREAD GUI PARENT oToolBar EXIT OPTIONS GetOptions

RETURN nil

* -------------------

STATIC FUNCTION PopupAction( aGetListItem )

RETURN {|p,q,o,x|x := aGetListItem[oGETLIST_OBJECT], ;
                 x:popup(o, {o:currentpos()[1]-o:currentpos()[1],o:currentPos()[2]},0, ;
                  XBPMENU_PU_DEFAULT+XBPMENU_PU_MOUSE_RBDOWN)}

* -------------------

FUNCTION RemoveBitmap( oItem, oDialog )

LOCAL cId, aBitmaps, aButtons, nIndex, oToolBar

cId := DC_GetProperty( oItem, cGETLIST_ID )

aButtons := ToolbarConfig()
aBitmaps := BitmapConfig()
oToolBar := Set_ToolBar()

nIndex := AScan( aBitmaps, {|c|c[1]==cId} )
IF nIndex > 0
  ARemove(aBitmaps,nIndex)
ENDIF

nIndex := AScan( aButtons, {|c|c==cId} )
IF nIndex > 0
  ARemove(aButtons,nIndex)
ENDIF

IF IsMethod(oItem,'SetImage')
  oItem:setImage(7329)
  oItem:setExpandedImage(7329)
  oItem:setMarkedImage(7329)
ENDIF

BitmapConfig( aBitmaps )
ToolbarConfig( aButtons )

BuildToolBar()

RETURN nil

* -------------------

FUNCTION ChooseButtonStyle()

LOCAL GetList[0], GetOptions, nStyle, aColor, lStatus, aButtonStyle

aButtonStyle := DC_RegQuery(HKEY_CURRENT_USER, ;
               'Software\Donnay Software\eXpress++','ButtonStyle' )

DEFAULT aButtonStyle := { 1, { 255,255,255 } }

@ 0, 0 DCSAY {||IIF(aButtonStyle[1]==1,'Classic Style','XP Style' )} ;
        SIZE 200, 25 COLOR GRA_CLR_BLUE FONT '12.Arial Bold'

@ 50, 0 DCPUSHBUTTON CAPTION BITMAP_CONFIG_M ;
       SIZE 31, 31 ;
       TOOLTIP 'Click to Choose Classic Style' ;
       ACTION {||aButtonStyle[1] := 1, DC_GetRefresh(GetList)}

@ 50,40 DCMXPUSHBUTTON ;
       BITMAP BITMAP_CONFIG_M BMPOS 3,3 ;
       SIZE 31, 31 ;
       COLOR nil, aButtonStyle[2] ;
       TOOLTIP 'Click to Choose XP Style' ;
       ACTION {||aButtonStyle[1] := 2, DC_GetRefresh(GetList)}

@ 100, 0 DCPUSHBUTTON CAPTION 'Choose Background Color' ;
        TOOLTIP 'Choose background color for XP Style Buttons' ;
        SIZE 200, 22 ;
        WHEN {||aButtonStyle[1]==2} ;
        ACTION {||aButtonStyle[2] := DC_PopColor( aButtonStyle[2], 2, .t., ;
                   'Choose Button Background Color',.t. )}

DCGETOPTIONS ;
   PIXEL ;
   TOOLTIPCOLOR GRA_CLR_BLACK, GRA_CLR_YELLOW ;
   TOOLTIPFONT '12.Lucida Console Bold'

DCREAD GUI ;
   FIT ;
   ADDBUTTONS ;
   TITLE 'Toolbar Button Style' ;
   TO lStatus ;
   MODAL ;
   OPTIONS GetOptions ;
   NOAUTORESTORE

IF lStatus
  DC_RegWrite(HKEY_CURRENT_USER, ;
             'Software\Donnay Software\eXpress++','ButtonStyle', aButtonStyle )
  BuildToolBar()
ENDIF

RETURN lStatus

* -------------------

FUNCTION ChooseBitmap( oItem )

STATIC nPointer := 1, aGoodBitmaps, aBitmapList[0]

LOCAL GetList := {}, oBrowse, aFiles, oBitMapStatic, bBitMap, nSeconds, ;
      lStatus, i, j, GetOptions, bBitMapName, aPres, nDll, cResource, ;
      cBitmapDir := '..\bitmaps\', aButtons, cId, nIndex, aBitmap[0], cBitmap, ;
      aMenuGetList[0], oMenuBar, aBitmaps2[0], nBitmap, nColPos := 1, ;
      aBitmaps[0], aDlls, cBitmapList := '', aTokens, cText, nResource, ;
      oStatus

IF aGoodBitmaps == nil

  aGoodBitmaps := Array(0)

  FOR i := 7000 TO 9998 // eXpress++ bitmaps
    IF GoodBitmap(i)
      AAdd(aGoodBitmaps, { Alltrim(Str(i)), i })
    ENDIF
  NEXT

  aFiles := Directory(cBitmapDir + '*.bmp')
  FOR i := 1 TO Len(aFiles)
    aFiles[i,1] := cBitmapDir + aFiles[i,1]
    IF GoodBitMap( aFiles[i,1])
      aFiles[i,2] := aFiles[i,1]
      AAdd(aGoodBitmaps,aFiles[i])
    ENDIF
  NEXT
  aFiles := Directory(cBitmapDir + '*.jpg')
  FOR i := 1 TO Len(aFiles)
    aFiles[i,1] := cBitmapDir + aFiles[i,1]
    IF GoodBitMap( aFiles[i,1])
      aFiles[i,2] := aFiles[i,1]
      AAdd(aGoodBitmaps,aFiles[i])
    ENDIF
  NEXT
  aFiles := Directory(cBitmapDir + '*.gif')
  FOR i := 1 TO Len(aFiles)
    aFiles[i,1] := cBitmapDir + aFiles[i,1]
    IF GoodBitMap( aFiles[i,1])
      aFiles[i,2] := aFiles[i,1]
      AAdd(aGoodBitmaps,aFiles[i])
    ENDIF
  NEXT
  aFiles := Directory(cBitmapDir + '*.png')
  FOR i := 1 TO Len(aFiles)
    aFiles[i,1] := cBitmapDir + aFiles[i,1]
    IF GoodBitMap( aFiles[i,1])
      aFiles[i,2] := aFiles[i,1]
      AAdd(aGoodBitmaps,aFiles[i])
    ENDIF
  NEXT

  aDlls := DC_BitmapResourceFile()
  IF Valtype(aDlls) == 'A'
    FOR i := 1 TO Len(aDlls)
      nDll := aDlls[i]
      cResource := LoadResource( 9999, nDll )
      IF Valtype( cResource ) = 'C'
        cBitmapList += cResource
      ENDIF
    NEXT
  ENDIF

  aTokens := DC_TokenArray( cBitmapList, CRLF )

  FOR i := 1 TO Len(aTokens)
    cText := Alltrim(aTokens[i])
    IF Empty(cText) .OR. !'BITMAP' $ cText
      LOOP
    ENDIF
    cText := Strtran( cText, '"', '')
    cText := Strtran( cText, "'", "")
    nResource := Val(Substr(cText, 1, At(' BITMAP',cText)-1 ))
    cBitmap := Ltrim(Substr(cText,At('BITMAP ',cText)+1))
    cBitmap := DC_Path(cBitmap,.t.)
    AAdd( aBitmapList, { nResource, cBitmap } )
  NEXT

ENDIF

IF Empty(aGoodBitMaps)
  DC_WinAlert('No .BMP, .JPG, or .GIF files found in ' + cBitmapDir + ' !')
  RETURN ''
ENDIF

aPres := ;
  { { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE },            /* Header FG Color  */  ;
    { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY },         /* Header BG Color  */  ;
    { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED }, /* Row Sep          */  ;
    { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED }, /* Col Sep          */  ;
    { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },            /* Row FG Color     */  ;
    { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },            /* Row BG Color     */  ;
    { XBP_PP_COL_DA_ROWHEIGHT, 30 },                   /* Row Height       */  ;
    { XBP_PP_COL_HA_HEIGHT, 10 },                      /* Header Height    */  ;
    { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },            /* Hilite FG color  */  ;
    { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },             /* Hilite BG color  */  ;
    { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },            /* Footer FG Color  */  ;
    { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },         /* Footer BG Color  */  ;
    { XBP_PP_COL_FA_HEIGHT, 10 }                       /* Footer Height    */  ;
  }

nBitmap := 0
FOR i := 1 TO Len(aGoodBitmaps)
  AAdd( aBitmap, aGoodBitmaps[i,1] )
  AAdd( aBitmap, aGoodBitmaps[i,2] )
  nBitmap++
  IF nBitmap = 10 .OR. i == Len(aGoodBitmaps)
    IF Len(aBitmap) < 20
      ASize(aBitmap,20)
      FOR j := 1 TO Len(aBitmap)
        IF Empty(aBitmap[j])
          aBitmap[j] := 0
        ENDIF
      NEXT
    ENDIF
    AAdd(aBitmaps,aBitmap)
    nBitmap := 0
    aBitmap := Array(0)
  ENDIF
NEXT

bBitmapName := {|a,b,o|BitmapName(oStatus,aBitmaps,oBrowse,aBitmapList,nPointer), ;
                       nColPos := o:colPos }

@ 0,0 dcbrowse oBrowse ;
      DATA aBitmaps ;
      SIZE 90,15 FIT ;
      PRESENTATION aPres ;
      FONT '10.Courier' ;
      POINTER nPointer ;
      NOHSCROLL ;
      NOSOFTTRACK ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      ITEMMARKED bBitMapName ;
      ITEMSELECTED {|a,b,o|nColPos := o:colPos, ;
                           DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

dcbrowsecol TYPE XBPCOL_TYPE_BITMAP ;
   DATA {||DC_GetBitMap(DC_GetColArray(2,oBrowse))} ;
   header 'Image' WIDTH 7 parent oBrowse

dcbrowsecol TYPE XBPCOL_TYPE_BITMAP ;
   DATA {||DC_GetBitMap(DC_GetColArray(4,oBrowse))} ;
   header 'Image' WIDTH 7 parent oBrowse

dcbrowsecol TYPE XBPCOL_TYPE_BITMAP ;
   DATA {||DC_GetBitMap(DC_GetColArray(6,oBrowse))} ;
   header 'Image' WIDTH 7 parent oBrowse

dcbrowsecol TYPE XBPCOL_TYPE_BITMAP ;
   DATA {||DC_GetBitMap(DC_GetColArray(8,oBrowse))} ;
   header 'Image' WIDTH 7 parent oBrowse

dcbrowsecol TYPE XBPCOL_TYPE_BITMAP ;
   DATA {||DC_GetBitMap(DC_GetColArray(10,oBrowse))} ;
   header 'Image' WIDTH 7 parent oBrowse

dcbrowsecol TYPE XBPCOL_TYPE_BITMAP ;
   DATA {||DC_GetBitMap(DC_GetColArray(12,oBrowse))} ;
   header 'Image' WIDTH 7 parent oBrowse

dcbrowsecol TYPE XBPCOL_TYPE_BITMAP ;
   DATA {||DC_GetBitMap(DC_GetColArray(14,oBrowse))} ;
   header 'Image' WIDTH 7 parent oBrowse

dcbrowsecol TYPE XBPCOL_TYPE_BITMAP ;
   DATA {||DC_GetBitMap(DC_GetColArray(16,oBrowse))} ;
   header 'Image' WIDTH 7 parent oBrowse

dcbrowsecol TYPE XBPCOL_TYPE_BITMAP ;
   DATA {||DC_GetBitMap(DC_GetColArray(18,oBrowse))} ;
   header 'Image' WIDTH 7 parent oBrowse

dcbrowsecol TYPE XBPCOL_TYPE_BITMAP ;
   DATA {||DC_GetBitMap(DC_GetColArray(20,oBrowse))} ;
   header 'Image' WIDTH 7 parent oBrowse

@ 16,0 DCSAY '' SAYSIZE 60 SAYLEFTCENTER ;
      COLOR GRA_CLR_BLUE, GRA_CLR_WHITE FONT '10.Lucida Console Bold' ;
      OBJECT oStatus

DCGETOPTIONS ;
   RESIZE ;
   _AUTORESIZE .f.

DCREAD GUI ;
   FIT ;
   ADDBUTTONS ;
   TITLE 'Choose Icon' ;
   TO lStatus ;
   MODAL ;
   OPTIONS GetOptions ;
   SETAPPWINDOW

IF lStatus

  aBitmap := aBitmaps[nPointer]
  cBitmap := aBitmap[(nColPos*2)]

  cId := DC_GetProperty( oItem, cGETLIST_ID )

  aBitmaps := BitmapConfig()

  DEFAULT aBitmaps := {}
  nIndex := AScan( aBitmaps, {|c|c[1]==cId} )
  aBitmap := { cBitmap, cBitmap }
  IF nIndex > 0
    aBitmaps[nIndex,2] := aBitmap
  ELSE
    AAdd( aBitmaps, { cId, aBitmap })
  ENDIF

  BitmapConfig( aBitmaps )

  BuildToolBar()

  IF IsMethod(oItem,'SetImage')
    oItem:setImage(DC_GetBitMap(aBitmap[1]))
    oItem:setExpandedImage(DC_GetBitMap(aBitmap[1]))
    oItem:setMarkedImage(DC_GetBitMap(aBitmap[1]))
  ENDIF

ENDIF

RETURN lStatus

* -------------------

FUNCTION BitmapName( oStatus, aBitmaps, oBrowse, aBitmapList, nPointer )

LOCAL aBitmap, nBitmap, nFound, cStatus

aBitmap := aBitmaps[nPointer]
nBitmap := aBitmap[(oBrowse:colPos*2)]
IF Valtype(nBitmap) == 'N'
  nFound := AScan( aBitmapList, {|a|a[1]==nBitmap} )
  cStatus := Alltrim(Str(nBitmap)) + ' = ' + IIF(nFound>0,aBitmapList[nFound,2],'Unknown')
ELSEIF Valtype(nBitmap) = 'C'
  cStatus := nBitmap
ELSE
  cStatus := ''
ENDIF

oStatus:setCaption(cStatus)

RETURN nil

* -------------------

FUNCTION GoodBitMap( xBitmap )

LOCAL oBitmap := XbpBitMap():new():create(), lStatus := .t., ;
      nResDll

IF Valtype(xBitmap) = 'C'
  oBitmap:loadFile(xBitmap)
ELSEIF Valtype(xBitmap) = 'N'
  nResDll := DllLoad('DCRES.DLL')
  oBitmap:load(nResDll,xBitmap)
ENDIF

IF (oBitmap:xSize > 26 .OR. oBitmap:ySize > 26 ) .OR. oBitmap:xSize = 0
  lStatus := .f.
ENDIF

/*
IF oBitmap:xSize < 25 .OR. oBitmap:ySize < 25 .OR. ;
   oBitmap:xSize > 26 .OR. oBitmap:ySize > 26
  lStatus := .f.
ENDIF
*/

oBitmap:destroy()

RETURN lStatus

* -------------------

FUNCTION _ActiveBlock( bBlock, oStatTop )

RETURN {|o|o:=Thread():new(),Sleep(5),o:Start(bBlock),Sleep(5), ;
           IIF(Valtype(oStatTop)=='O',oStatTop:invalidateRect(),nil)}

* -------------------

STATIC FUNCTION _XDemoExit( GetList )

IF DC_MsgBox(,,{'Are you sure you want to Quit the eXPress++ Demo?'}, ;
      'eXPress++',,,.t.)
  QUIT
ENDIF

RETURN nil

* ------------------

FUNCTION _UpdateStats( GetList )

STATIC snCaps := 0, snNum := 0

LOCAL oCapsLock := DC_GetObject(GetList,'CAPSLOCK')
LOCAL oNumLock  := DC_GetObject(GetList,'NUMLOCK')
LOCAL oInsert   := DC_GetObject(GetList,'INSERT')
LOCAL nCaps     := AppKeystate( VK_CAPITAL, .T. )
LOCAL nNum      := AppKeystate( VK_NUMLOCK, .T. )
LOCAL oCapsStatic, oNumStatic

IF Valtype(oCapsLock) # 'O' .OR. Valtype(oNumLock) # 'O' .OR. Valtype(oInsert) # 'O'
  RETURN nil
ENDIF

oNumStatic := oNumLock:setParent()
IF nNum == APPKEY_PRESSED
  oNumLock:enable()
ELSE
  oNumLock:disable()
ENDIF

oCapsStatic := oCapsLock:setParent()
IF nCaps == APPKEY_PRESSED
  oCapsLock:enable()
ELSE
  oCapsLock:disable()
ENDIF

IF ReadInsert()
  oInsert:SetCaption( "Ins" )
ELSE
  oInsert:SetCaption( "Ovr" )
ENDIF

RETURN nil


// Retrieving Computername

#INCLUDE "DLL.CH"

DLLFUNCTION RegOpenKeyExA(nHkeyClass, cKeyName, reserved, access, @nKeyHandle);
            USING STDCALL FROM ADVAPI32.DLL

DLLFUNCTION RegQueryValueExA(nKeyHandle, cEntry, reserved, @valueType, ;
            @cName, @nSize);
            USING STDCALL FROM ADVAPI32.DLL

DLLFUNCTION RegCloseKey( nKeyHandle );
            USING STDCALL FROM ADVAPI32.DLL

FUNCTION GetNetName()

LOCAL nHKey      := 2147483650
LOCAL cKeyName   := "System\CurrentControlSet\Control\ComputerName\ComputerName"
LOCAL cEntryName := "Computername"
LOCAL cName := "", rc
LOCAL nNameSize
LOCAL nKeyHandle
LOCAL nValueType
nKeyHandle := 0
IF RegOpenKeyExA(nHKey, cKeyName,0, 1, @nKeyHandle) = 0
  nValueType  := 0
  nNameSize  := 0
  RegQueryValueExA(nKeyHandle, cEntryName, 0, @nValueType, 0, @nNameSize)
  IF nNameSize > 0
    cName := space( nNameSize )
    rc := RegQueryValueExA(nKeyHandle, cEntryName,;
                           0, @nValueType, @cName, @nNameSize)
  ENDIF
  RegCloseKey( nKeyHandle)
ENDIF

RETURN (upper(alltrim(cName)))

* -----------------

STATIC FUNCTION LoadHelpOptions( oDialog )

LOCAL cDataPath, cHtmlPath, cScriptPath, cTempPath, ;
      aHelpOptions := DC_HelpOptions()

cDataPath := DC_Path(AppName(.t.)) + '..\DATA\'
cScriptPath := DC_Path(AppName(.t.)) + '..\SCRIPTS\'
cHtmlPath := DC_Path(AppName(.t.)) + '..\HTML\'
cTempPath := DC_Path(AppName(.t.)) + '..\HTML\'

cDataPath := _CheckPath(cDataPath)
cScriptPath := _CheckPath(cScriptPath)
cHtmlPath := _CheckPath(cHtmlPath)
cTempPath := _CheckPath(cTempPath)

// Install global handler.
DC_ReadGuiHandler({|a,b,c,d,e,f|Xdemo_Handler(a,b,c,d,e,f)})

aHelpOptions[HELP_OPTIONS_HOTKEYFOCUS] := xbeK_ALT_F11    // Hot key to View Focus Item info in window
aHelpOptions[HELP_OPTIONS_HELPREQUEST] := xbeK_ALT_F1     // Hot key to send Help Request for focus item
aHelpOptions[HELP_OPTIONS_KEYBLOCK   ] := {||.t.}         // Code block to enable hot keys
aHelpOptions[HELP_OPTIONS_EDITBLOCK  ] := {||.t.}         // Code block to enable help editing
aHelpOptions[HELP_OPTIONS_FONT       ] := '10.Courier'    // Font of Help Window
aHelpOptions[HELP_OPTIONS_TITLE      ] := 'XDEMO Help'    // Title of Help Window
aHelpOptions[HELP_OPTIONS_ROOT       ] := 'DESKTOP'       // Help Root Name
aHelpOptions[HELP_OPTIONS_TYPE       ] := 4               // Help Type
aHelpOptions[HELP_OPTIONS_DATABASE   ] := cDataPath + 'HELP.DBF'      // Help Database Alias Name
aHelpOptions[HELP_OPTIONS_PARENT     ] := nil             // Parent of Help Window
aHelpOptions[HELP_OPTIONS_WINHEIGHT  ] := 400             // Help Window Height
aHelpOptions[HELP_OPTIONS_WINWIDTH   ] := 620             // Help Window Width
aHelpOptions[HELP_OPTIONS_FIND       ] := cDataPath + 'HELPFIND.DBF'  // Help Find Database Alias Name
aHelpOptions[HELP_OPTIONS_EXITMODE   ] := HELP_EXITMODE_DESTROY   // Help Exit Mode
aHelpOptions[HELP_OPTIONS_SCRIPTPATH ] := cScriptPath     // Script Path
aHelpOptions[HELP_OPTIONS_HTMLPATH   ] := cHtmlPath       // HTML Path
aHelpOptions[HELP_OPTIONS_TEMPPATH   ] := cTempPath       // Temp files path

DC_HelpOptions( aHelpOptions )

RETURN nil

* -----------

STATIC FUNCTION _CheckPath(cPath)

IF Empty(Directory(cPath+'*.*'))
  cPath := DC_CurPath() + '/'
ENDIF

RETURN cPath

* -----------

FUNCTION ViewHelpCodes(GetList)

LOCAL i, aHelpCodes[0]

FOR i := 1 TO LEN(GetList)
  AAdd(aHelpCodes,DC_XtoC(GetList[i,cGETLIST_HELPCODE]) + ' - ' + DC_GetListType(GetList[i,nGETLIST_TYPE]))
NEXT

DC_ArrayView(aHelpCodes)

RETURN nil

* -----------

STATIC FUNCTION About()

DC_WinAlert('Not Completed!')

RETURN nil

* -----------

STATIC FUNCTION Xdemo_Handler( nEvent, mp1, mp2, oXbp, oDlg, aGetList )

LOCAL oPrintMenu, GetList[0]

IF nEvent == xbeP_Keyboard .AND. mp1 == xbeK_CTRL_P

  IF Empty(oDlg)
    oDlg := oXbp
    DO WHILE !oDlg:isDerivedFrom('XbpDialog')
      oDlg := oDlg:setParent()
    ENDDO
  ENDIF

  DCSUBMENU oPrintMenu PARENT oXbp

    DCMENUITEM 'Display Image in another Window' ;
      ACTION {||DisplayImage(oDlg)} PARENT oPrintMenu

    DCMENUITEM 'Print WYSIWYG (Current Object)' PARENT oPrintMenu ;
      ACTION {||DC_PrintImage(oDlg,1)} ;
      WHEN {||!oXbp:isDerivedFrom('XbpDialog')}

    DCMENUITEM 'Print WYSIWYG (All TabPages)' PARENT oPrintMenu ;
      ACTION {||DC_PrintImage(oDlg,2)} ;
      WHEN {||oXbp:isDerivedFrom('XbpDialog')}

    DCMENUITEM SEPARATOR PARENT oPrintMenu ;

    DCMENUITEM 'Show Source Code for this Object' ;
      ACTION {||DC_ShowSourceCode(oDlg)} ;
      PARENT oPrintMenu

   DCREAD GUI PARENT AppDeskTop() EXIT

   oPrintMenu:popup( oDlg, {0,0}, 1 , XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN )

   RETURN DCGUI_IGNORE

ENDIF

RETURN DC_HelpHandler( nEvent, mp1, mp2, oXbp, oDlg, GetList )


* -----------

STATIC FUNCTION DisplayImage( oXbp )

LOCAL GetList[0], GetOptions, oSourcePS, oBitmap, oDlg, aPos

STATIC saPos

oXbp:toFront()
IF oXbp:isDerivedFrom('XbpDialog')
  aPos := { -3, -3 }
ELSE
  aPos := { 0, 0 }
ENDIF

oSourcePS := oXbp:LockPS()
oBitmap := GraSaveScreen( oSourcePS, aPos, oXbp:currentSize() )
oBitmap:saveFile('c:\expd19\samples\xdemo\screen.bmp',XBPBMP_FORMAT_WIN3X)

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP CAPTION oBitmap ;
      PIXEL

DCGETOPTIONS PIXEL HIDE

DCREAD GUI FIT TITLE 'Screen Capture' MODAL NODESTROY ;
   EVAL {|o|oDlg := o, ;
         IIF(!Empty(saPos),oDlg:setPos(saPos),nil), ;
         o:show()} ;
   OPTIONS GetOptions ;
   NOAUTORESTORE

saPos := oDlg:currentPos()

oDlg:destroy()

RETURN nil

* -----------

// REQUIRED by the JA runtime to process smoothly the OCX events sent by the various ActiveX instances.
#if XPPVER < 1900000
STATIC PROCEDURE JAProcessOCXEvents()
  JAXPPPROCESSEVENTS()
RETURN
#endif

* ----------

STATIC FUNCTION SelectWindow( oDialog )

LOCAL i, aChildList := oDialog:drawingArea:childList()
STATIC slWindow := 1

slWindow++
IF slWindow > Len(aChildList)
  slWindow := 1
ENDIF

SetAppFocus(aChildlist[slWindow])

RETURN nil

* ----------

STATIC FUNCTION DC_ShowSourceCode( oXbp )

LOCAL oGetList, aGetOptions, cEditor, cSourceFile, cProcedure, ;
      nLineNumber, aGetList, aGetListItem

cEditor := DC_Sett('EDITOR')
IF Empty(cEditor)
  DC_WinAlert('No EDITOR defined.' + Chr(13) + ;
              'Use the function DC_Sett("EDITOR",<myeditor>)' + Chr(13) + ;
              'Where <myeditor> is a batch file that calls your editor' + Chr(13) + ;
              'The Source file name and line number will be passed.')
  RETURN .f.
ENDIF

IF Valtype(oXbp) == 'O' .AND. IsMemberVar(oXbp,'GetList')
  oGetList := oXbp:getList
  aGetOptions := oGetList:getOptions
  aGetList := oGetList:getListArray
ELSE
  DC_WinAlert('This is not an object created by eXpress++')
  RETURN .f.
ENDIF

cSourceFile := aGetOptions[cGETOPT_SOURCECODE]

IF Empty(cSourceFile)
  DC_WinAlert('No SOURCECODE defined.' + Chr(13) + ;
              'Add the SOURCECODE <filename> clause to DCGETOPTIONS of each' + Chr(13) + ;
              'Dialog window, where <filename> is the full path of the source code')
  RETURN nil
ENDIF

aGetListItem := oGetList:getListArray[oXbp:getListPointer]

cProcedure := aGetListItem[aGETLIST_PROC,1]
nLineNumber := aGetListItem[aGETLIST_PROC,2]

IF !File(cEditor)
  DC_WinAlert('Cannot find editor: ' + cEditor)
  RETURN .f.
ENDIF

RunShell(cSourceFile + ' ' + Alltrim(Str(nLineNumber)), cEditor,.t.,.t.)

RETURN .t.

FUNCTION MaximizeScreen( oDlg )
*******************************
LOCAL aWorkArea, nRow, nCol, nWidth, nHeight

// nWidth := oDlg:currentSize()[1]
// nHeight := oDlg:currentSize()[2]

aWorkArea := DC_GetWorkArea()
nHeight := aWorkArea[4] - aWorkArea[2]
nWidth := aWorkArea[3] - aWorkArea[1]
nCol := aWorkArea[1]
nRow := oDlg:setParent():currentSize()[2] - aWorkArea[4]

oDlg:setPos({nCol,nRow})
oDlg:setSize({nWidth,nHeight})

DC_CompleteEvents()

RETURN nil